if select(2, UnitClass("player")) ~= "WARLOCK" then return end
local GetSpellInfo = DrDamage.SafeGetSpellInfo
local UnitHealth = UnitHealth
local UnitHealthMax = UnitHealthMax
local UnitBuff = UnitBuff
local UnitDebuff = UnitDebuff
local UnitExists = UnitExists
local UnitIsFriend = UnitIsFriend
local UnitPower = UnitPower
local UnitPowerMax = UnitPowerMax
local UnitIsUnit = UnitIsUnit
local math_min = math.min
local math_max = math.max
local math_ceil = math.ceil
local select = select
local GetPetSpellBonusDamage = GetPetSpellBonusDamage
local GetSpellCritChanceFromIntellect = GetSpellCritChanceFromIntellect
local Orc = (select(2,UnitRace("player")) == "Orc")
local IsSpellKnown = IsSpellKnown

local spells = { [GetSpellInfo(7814) or "Lash of Pain"] = true, [GetSpellInfo(54049) or "Shadow Bite"] = true, [GetSpellInfo(3110) or "Firebolt"] = true, }
function DrDamage:UpdatePetSpells()
	self:UpdateAB(spells)
end

function DrDamage:PetWeaponDamage(calculation)
	local min, max, omin, omax, mod
	local normM, normM_O, bonus, obonus, baseAP
	min, max, omin, omax, _, _, mod = UnitDamage("pet")
	baseAP = self:GetPetAP()
	normM, normM_O = self:GetNormM()
end


function DrDamage:PlayerData()
	--Health updates
	self.PlayerHealth = { [1] = 0.251, [0.251] = GetSpellInfo(689) }
	self.TargetHealth = { [1] = 0.251, }
--GENERAL
	self.Calculation["Stats"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		local mastery = calculation.mastery
		local masteryLast = calculation.masteryLast
		local spec = calculation.spec
		if spec == 1 then
			if mastery > 0 and mastery ~= masteryLast then
				if baseSpell.Affliction then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM - masteryBonus
					end
					local bonus = 1 + (mastery * 0.01)
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				end
			end
		elseif spec == 2 then
			if mastery > 0 and mastery ~= masteryLast then
				if calculation.group == "Pet" then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM / masteryBonus
					end
					--NOTE: For Pet tooltips only base damage is affected
					--Mastery: Master Demonologist
					local bonus = 1 + mastery * 0.01 
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				else
					if ActiveAuras["Metamorphosis"] then
						local masteryBonus = calculation.masteryBonus
						if masteryBonus then
							calculation.dmgM = calculation.dmgM / masteryBonus
						end
						--Metamorphosis mastery is 3 times greater than the mastery effect lists.
						local bonus = 1 + (mastery * 0.01 * 3) 
						calculation.dmgM = calculation.dmgM * bonus
						calculation.masteryLast = mastery
						calculation.masteryBonus = bonus
					else
						local masteryBonus = calculation.masteryBonus
						if masteryBonus then
							calculation.dmgM = calculation.dmgM / masteryBonus
						end
						local bonus = 1 + (mastery * 0.01)
						calculation.dmgM = calculation.dmgM * bonus
						calculation.masteryLast = mastery
						calculation.masteryBonus = bonus
					end
				end
			end
		elseif spec == 3 then
			if mastery > 0 and mastery ~= masteryLast then
				if baseSpell.BurningEmbers then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM / masteryBonus
					end
					--Mastery: Fiery Apocalpyse
					local bonus = 1 + (mastery * 0.01)
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				elseif baseSpell.Emberstorm then
					local masteryBonus = calculation.masteryBonus
					if masteryBonus then
						calculation.dmgM = calculation.dmgM / masteryBonus
					end
					local bonus = 1 + (mastery * 0.01 * 3)
					calculation.dmgM = calculation.dmgM * bonus
					calculation.masteryLast = mastery
					calculation.masteryBonus = bonus
				end
			end
		end
	end
	self.Calculation["WARLOCK"] = function( calculation, ActiveAuras, Talents, spell, baseSpell )
		--General stats
		if IsSpellKnown(86091) then
			calculation.intM = calculation.intM * 1.05
		end
		--General bonuses
		if calculation.group == "Pet" then
			if Orc then
				calculation.dmgM = calculation.dmgM * 1.05
			end
		else
			--TODO: Verify
			if ActiveAuras["Metamorphosis"] == 0 then
				calculation.dmgM = calculation.dmgM * 1.2
			end
		end
		if not baseSpell.NoSchoolTalents then
			local spec = calculation.spec
			if spec == 1 then
				-- Checked in 4.1 - Shadow Mastery bonus went from 25% to 30%
				if calculation.school == "Shadow" or calculation.school == "Shadowflame" then
					--NOTE: Pets don't gain, but tooltips show base damage gain
					if calculation.group ~= "Pet" then
						if calculation.spellName == "Haunt" then
							--BUG: Haunt only gains base damage?
							calculation.bDmgM = calculation.bDmgM * 1.3
						else
							calculation.dmgM = calculation.dmgM * 1.3
						end
					end
				end
			elseif spec == 2 then
				if calculation.school == "Shadow" or calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						--Multiplicative 4.0
						calculation.dmgM = calculation.dmgM * 1.15
					end
				end
			elseif spec == 3 then
				if calculation.school == "Fire" or calculation.school == "Shadowflame" then
					if calculation.group ~= "Pet" then
						calculation.dmgM = calculation.dmgM * 1.25
					end
				end
			end
		end
	end
--ABILITIES
	local damage_text = GetSpellInfo(48360)
	self.Calculation["Life Tap"] = function( calculation, _, Talents )
		if not self:HasGlyph(63320) then
			local amount = UnitHealthMax("player") * 0.15  
			calculation.minDam = amount
			calculation.maxDam = amount
			calculation.customText = damage_text
			calculation.customTextValue = 0.15 * UnitHealthMax("player")
		end
	end
	local heal = GetSpellInfo(2050)
	self.Calculation["Drain Life"] = function( calculation, ActiveAuras, Talents )
		--calculation.customTextValue = 0.06 * UnitHealthMax("player") * (ActiveAuras["Demon Armor"] or 1)
		calculation.customTextValue = 0.02 * UnitHealthMax("player")
		if ActiveAuras["Soulburn"] then
			calculation.customTextValue = calculation.customTextValue * 1.5
		end
		if ActiveAuras["Demon Armor"] then
			calculation.customTextValue = calculation.customTextValue * 1.1
		end
		if self:HasGlyph(63302) then
			calculation.customTextValue = calculation.customTextValue * 1.3
		end
		calculation.customText = heal
	end
	self.Calculation["Drain Soul"] = function ( calculation, ActiveAuras, Talents, spell )
		if UnitHealth("target") ~= 0 and (UnitHealth("target") / UnitHealthMax("target")) <= 0.2 then
			calculation.minDam = calculation.minDam * 2
			calculation.maxDam = calculation.maxDam * 2
		end
	end
	--self.Calculation["Incinerate"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Soul Fire"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Chaos Bolt"] = function( calculation, ActiveAuras, Talents )
	--end
	--self.Calculation["Immolate"] = function( calculation )
	--end
	--self.Calculation["Corruption"] = function( calculation )
	--end
	--self.Calculation["Conflagrate"] = function( calculation, ActiveAuras, Talents )
	--end
	--self.Calculation["Unstable Affliction"] = function( calculation )
	--end
	--self.Calculation["Shadow Bolt"] = function( calculation )
	--end
	--self.Calculation["Immolation Aura"] = function( calculation, ActiveAuras )
	--end
	--self.Calculation["Demon Leap"] = function( calculation, ActiveAuras )
	--end
	--self.Calculation["Firebolt"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Shadow Bite"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	--self.Calculation["Lash of Pain"] = function( calculation, ActiveAuras, Talents, spell )
	--end
	self.Calculation["Rain of Fire"] = function ( calculation, ActiveAuras )
		local spec = calculation.spec
		if ActiveAuras["Immolate"] and spec == 3 then
			calculation.dmgM = calculation.dmgM * 1.5
		end
	end
--SETS
	self.SetBonuses["T10"] = { 50240, 50241, 50242, 50243, 50244, 51230, 51231, 51232, 51233, 51234, 51205, 51206, 51207, 51208, 51209, }
--AURA
--Player
	--Metamorphosis - TODO: Verify aura ID.
	self.PlayerAura[GetSpellInfo(103965)] = { ActiveAura = "Metamorphosis", Index = true, ID = 103965 }
	--Soulburn
	self.PlayerAura[GetSpellInfo(74434)] = { ActiveAura = "Soulburn", Spells = { "Soul Fire", "Drain Life" }, ID = 74434 }
	--TODO: Demon Soul: Felguard. Does API handle it?
	--Dark Soul: Instability
	self.PlayerAura[GetSpellInfo(113858)] = { ActiveAura = "Dark Soul: Instability", Value = 30, ModType = "critPerc" }
--Target
	--Immolate
	self.TargetAura[GetSpellInfo(348)] = { ActiveAura = "Immolate", Spells = { "Incinerate", "Conflagrate", "Chaos Bolt" }, SelfCast = true, ID = 348 }
	--Soul Siphon
		--Agony
		self.TargetAura[GetSpellInfo(980)] = 	self.TargetAura[GetSpellInfo(172)]
		--Doom
		self.TargetAura[GetSpellInfo(603)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Weakness
		self.TargetAura[GetSpellInfo(702)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Tongues
		self.TargetAura[GetSpellInfo(1714)] = 	self.TargetAura[GetSpellInfo(172)]
		--Curse of Exhaustion
		self.TargetAura[GetSpellInfo(18223)] = 	self.TargetAura[GetSpellInfo(172)]
		--Unstable Affliction
		self.TargetAura[GetSpellInfo(30108)] = 	self.TargetAura[GetSpellInfo(172)]
		--Seed of Corruption
		self.TargetAura[GetSpellInfo(27243)] = 	self.TargetAura[GetSpellInfo(172)]
		--Fear
		self.TargetAura[GetSpellInfo(5782)] = 	self.TargetAura[GetSpellInfo(172)]
		--Howl of Terror
		self.TargetAura[GetSpellInfo(5484)] = 	self.TargetAura[GetSpellInfo(172)]
--Custom
	--Demon Armor
	self.PlayerAura[GetSpellInfo(79934)] = { Spells = { "Drain Life" }, ID = 687, ModType =
		function( calculation, ActiveAuras, Talents )
			calculation.leechBonus = (calculation.leechBonus or 0) * 1.2 
			ActiveAuras["Demon Armor"] = 1.2 
		end
	}
	--Backdraft
	self.PlayerAura[GetSpellInfo(117828)] = { NoManual = true, ModType =
		function( calculation, _, Talents )
			calculation.haste = calculation.haste * 1.3
		end
	}
	--Haunt
	self.TargetAura[GetSpellInfo(48181)] = { School = "Shadow", SelfCast = true, ID = 48181, Not = { "Pet" }, Value = 0.3, ModType = "dmgM" }

	self.spellInfo = {
		[GetSpellInfo(172)] = {
			["Name"] = "Corruption",
			["ID"] = 172,
			["Data"] = { 1.803, 0, 0.2 },
			[0] = { School = { "Shadow" }, Hits = 9, eDot = true, eDuration = 18, sTicks = 2, Affliction = true },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(686)] = {
			["Name"] = "Shadow Bolt",
			["ID"] = 686,
			["Data"] = { 0.62, 0.11, 0.754, ["ct_min"] = 1700, ["ct_max"] = 2500 },
			[0] = { School = { "Shadow" } },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(1454)] = {
			["Name"] = "Life Tap",
			["ID"] = 1454,
			[0] = { School = { "Shadow", "Utility", }, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(6229)] = {
			["Name"] = "Shadow Ward",
			["ID"] = 6229,
			["Data"] = { 3, 0 },
			[0] = { School = { "Shadow", "Absorb" }, SPBonus = 3, NoCrits = true, NoGlobalMod = true, NoTargetAura = true, NoSchoolTalents = true, NoDPS = true, NoNext = true, NoDPM = true, NoDoom = true, Unresistable = true, },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(980)] = {
			["Name"] = "Agony",
			["ID"] = 980,
			["Data"] = { 0.0539, 0, 0.026 },
			[0] = { School = { "Shadow" }, Hits = 12, eDot = true, eDuration = 24, sTicks = 2, Affliction = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(603)] = {
			["Name"] = "Doom",
			["ID"] = 603,
			["Data"] = { 1.25, 0, 1.25  },
			[0] = { School = { "Shadow" }, Hits = 4, eDot = true, eDuration = 60, sTicks = 15 },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(689)] = {
			["Name"] = "Drain Life",
			["ID"] = 689,
			["Data"] = { 0.334, 0, 0.334 },
			[0] = { School = { "Shadow" }, Hits = 6, sTicks = 1, Channeled = 6, Drain = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(1120)] = {
			["Name"] = "Drain Soul",
			["ID"] = 1120,
			["Data"] = { 0.3903, 0, 0.375  },
			[0] = { School = { "Shadow" }, Hits = 5, sTicks = 3, Channeled = 15, Drain = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(6353)] = {
			["Name"] = "Soul Fire",
			["ID"] = 6353,
			["Data"] = { 0.8539, 0.2, 0.8539 },
			[0] = { School = { "Fire" } },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(17877)] = {
			["Name"] = "Shadowburn",
			["ID"] = 17877,
			["Data"] = { 3.5, 0.2, 3.5 },
			[0] = { School = { "Shadow" }, Cooldown = 15, Emberstorm = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(348)] = {
			["Name"] = "Immolate",
			["ID"] = 348,
			["Data"] = { 0.4269, 0, 0.4269, 2.1344, 0, 0.4269 },
			[0] = { School = { "Fire" }, Hits_dot = 5, eDuration = 15, sTicks = 3, BurningEmbers = true },
			[1] = { 0, 0, hybridDotDmg = 0, },
		},
		[GetSpellInfo(1949)] = {
			["Name"] = "Hellfire",
			["ID"] = 1949,
			["Data"] = { 0.2099, 0, 0.2099, },
			[0] = { School = { "Fire" }, Hits = 14, Channeled = 14, sTicks = 1, AoE = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(5740)] = {
			["Name"] = "Rain of Fire",
			["ID"] = 5740,
			["Data"] = { 0.2499, 0, 0.2499, },
			[0] = { School = { "Fire" }, Hits = 6, Channeled = 6, sTicks = 1, AoE = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(30108)] = {
			["Name"] = "Unstable Affliction",
			["ID"] = 30108,
			["Data"] = { 1.6775, 0, 0.2499 },
			[0] = { School = { "Shadow" }, Hits = 7, eDot = true, eDuration = 14, sTicks = 2, Affliction = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(17962)] = {
			["Name"] = "Conflagrate",
			["ID"] = 17962,
			["Data"] = { 1.725, 0.1, 1.725 }, 
			[0] = { School = { "Fire" }, BurningEmbers = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(27243)] = {
			["Name"] = "Seed of Corruption",
			["ID"] = 27243,
			["Data"] = { 0.91, 0.15, 0.91, 1.2581, 0, 0.21  },
			["Data2"] = function(baseSpell, spell, playerLevel)
				baseSpell.Cap = 2.113 * self.Scaling[playerLevel]
				baseSpell.Cap_SPBonus = 0.1716
				end,
			[0] = { School = { "Shadow" }, Hits_dot = 6, eDuration = 18, sTicks = 3, NoDotAverage = true, AoE = true },
			[1] = { 0, 0, hybridDotDmg = 0 },
		},
		[GetSpellInfo(29722)] = {
			["Name"] = "Incinerate",
			["ID"] = 29722,
			["Data"] = { 1.5399, 0.1, 1.5399 },
			[0] = { School = { "Fire" }, BurningEmbers = true },
			[1] = { 0, 0, 0, 0 },
		},
		[GetSpellInfo(48181)] = {
			["Name"] = "Haunt",
			["ID"] = 48181,
			["Data"] = { 1.75, 0, 1.75 },
			[0] = { School = { "Shadow" }, Cooldown = 8 },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(116858)] = {
			["Name"] = "Chaos Bolt",
			["ID"] = 116858,
			["Data"] = { 2.25, 0.2, 2.25, },
			[0] = { School = { "Fire" }, Emberstorm = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(50589)] = GetSpellInfo(1949),
		[GetSpellInfo(3110)] = {
			["Name"] = "Firebolt",
			["ID"] = 3110,
			["Data"] = { 0.907, 0, 0.907, ["ct_min"] = 1250, ["ct_max"] = 1750 },
			[0] = { School = { "Fire", "Pet" }, SPBonus = 0.907, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, NoDPSC = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(54049)] = {
			["Name"] = "Shadow Bite",
			["ID"] = 54049,
			["Data"] = { 0.3799, 0, 0.3799 },
			[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.3799, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(7814)] = {
			["Name"] = "Lash of Pain",
			["ID"] = 7814,
			["Data"] = { 0.907, 0, 0.907},
			[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.907, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(86121)] = {
			["Name"] = "Soul Swap",
			["ID"] = 86121,
			["Data"] = { 0.5, 0, 0.5 },
			[0] = { School = { "Shadow", "Affliction" }, },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(71521)] = {
			["Name"] = "Hand of Gul'Dan",
			["ID"] = 105174,
			["Data"] = { 0.5747, 0, 0.5747, 0.82, 0, 0.137 },
			[0] = { School = "Shadowflame", Double = { "Shadow", "Fire" }, eDot = true, Hits = 6, sTicks = 1, AoE = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(77799)] = {
			["Name"] = "Fel Flame",
			["ID"] = 77799,
			["Data"] = { 0.75, 0.1, 0.75 },
			[0] = { School = "Shadowflame", Double = { "Shadow", "Fire" }, BurningEmbers = true },
			[1] = { 0, 0, },
		},
		[GetSpellInfo(103103)] = {
			["Name"] = "Malefic Grasp",
			["ID"] = 103103,
			["Data"] = { 0.2, 0, 0.2 },
			[0] = { School = "Shadow", Hits = 4, Channeled = 4, sTicks = 1 },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(112089)] = {
			["Name"] = "Metamorphosis: Touch of Chaos",
			["ID"] = 112089,
			["Data"] = { 0.7671, 0, 0.7671 }, 
			[0] = { School = "Chaos" },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(103967)] = {
			["Name"] = "Carrion Swarm",
			["ID"] = 103967,
			["Data"] = { 0.5, 0.1, 0.5 },
			[0] = { School = "Shadow", Cooldown = 12, AoE = true },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(124917)] = {
			["Name"] = "Metamorphosis: Chaos Wave",
			["ID"] = 124917,
			["Data"] = { 1, 0, 1.167 }, 
			[0] = { School = "Shadow", AoE = true },
			[1] = { 0, 0 },
		},
		[GetSpellInfo(129343)] = {
			["Name"] = "Metamorphosis: Void Ray",
			["ID"] = 129343,
			["Data"] = { 0.2, 0.1, 0.2 },
			[0] = { School = "Shadowflame", Double = { "Fire", "Shadow" }, AoE = true },
			[1] = { 0, 0 },
		},
		--Felguard
		[GetSpellInfo(103134)] = {
			["Name"] = "Felguard: Felstorm",
			["ID"] = 103134,
			[0] = { School = { "Physical", "Pet" }, PetWeaponDamage = 1 },
			[1] = { 0, 0 },
		},
		--Felguard
		[GetSpellInfo(30213)] = {
			["Name"] = "Legion Strike",
			["ID"] = 30213,
			[0] = { School = { "Physical", "Pet" }, PetWeaponDamage = 1.3 },
			[1] = { 0, 0 },
		},
		--Wrathguard
		[GetSpellInfo(115625)] = {
			["Name"] = "Mortal Cleave",
			["ID"] = 115625,
			[0] = { School = { "Physical", "Pet" }, PetWeaponDamage = 1.95 },
			[1] = { 0, 0 },
		},
		--Wrathguard
		[GetSpellInfo(115831)] = {
			["Name"] = "Wrathstorm", 
			["ID"] = 115831,
			[0] = { School = { "Physical", "Pet" }, PetWeaponDamage = 1 },
			[1] = { 0, 0 },
		},
		--Fel Imp
		[GetSpellInfo(115746)] = {
			["Name"] = "Felbolt",
			["ID"] = 115746,
			["Data"] = { 0.907, 0.1, 0.907, ["ct_min"] = 1250, ["ct_max"] = 1750 },
			[0] = { School = { "Fire", "Pet" }, SPBonus = 0.907, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, NoDPSC = true },
			[1] = { 0, 0 },
		},
		--Observer
		[GetSpellInfo(115778)] = {
			["Name"] = "Tongue Lash",
			["ID"] = 115778,
			["Data"] = { 0.3799, 0, 0.3799 },
			[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.3799, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0 },
		},
		--Observer
		[GetSpellInfo(115781)] = { 
			["Name"] = "Optic Blast",
			["ID"] = 115781,
			["Data"] = { 0.14, 0, 0.14 },
			[0] = { School = { "Shadow", "Pet" }, SPBonus = 0.14, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0 },
		},
		--Abyssal
		[GetSpellInfo(112921)] = {
		--Data found in Spell ID: 22703 (the missile summoned by the infernal)
			["Name"] = "Summon Abyssal",
			["ID"] = 112921,
			["Data"] = { 1 * 30, 0.1199, 1 * 30 },
			[0] = { School = { "Fire", "Pet" }, Cooldown = 600, Hits = 30, sTicks = 2, eDuration = 60, SPBonus = 1, AoE = true, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0 },
		},
		--Terrorguard
		[GetSpellInfo(112927)] = {
			["Name"] = "Summon Terrorguard",
			["ID"] = 112927,
			["Data"] = { 0.90 * 20, 0.1199, 0.90 * 20 },
			[0] = { School = { "Shadow", "Pet" }, Cooldown = 600, Hits = 20, sTicks = 3, eDuration = 60, SPBonus = 0.9, NoGlobalMod = true, NoManaCalc = true, NoNext = true, NoMPS = true, NoDPM = true, },
			[1] = { 0, 0 },
		},
	}
	self.talentInfo = {
	--AFFLICTION
	--DEMONOLOGY
	--DESTRUCTION:
	}
end
